<template>
  <div class="app-container">

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column :label="$t('序号')" type="index" width="50" />

      <el-table-column :label="$t('归属仓库')" align="center" prop="warehouseName" />
      
      <el-table-column :label="$t('区域编码')" align="center" prop="regionCode" />
      <el-table-column :label="$t('货架编号')" align="center" prop="shelfNo" />
     
      <el-table-column :label="$t('货架类型')" align="center" prop="shelfType">
        <template slot-scope="scope">
            <span>{{ shelfTypeName(scope.row.shelfType) }}</span>
          </template>
      </el-table-column>

      <el-table-column :label="$t('排序')" align="center" prop="sort" />

      <el-table-column :label="$t('状态')" align="center" prop="status">
        <template slot-scope="scope">
           <span>{{ statusName(scope.row.status) }}</span>
        </template>
      </el-table-column>
      
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:shelf:update']">{{ $t('修改') }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('区域编码')" prop="regionCode">
          <el-input v-model="form.regionCode" :placeholder="$t('请输入区域编码')" disabled />
        </el-form-item>
        <el-form-item :label="$t('货架编号')" prop="shelfNo">
          <el-input v-model="form.shelfNo" :placeholder="$t('请输入货架编号')" disabled />
        </el-form-item>
        <el-form-item :label="$t('库存容量')" prop="volume">
          <el-input v-model="form.volume" :placeholder="$t('请输入库存容量')" />
        </el-form-item>
         <el-form-item :label="$t('排序')" prop="sort">
          <el-input v-model="form.sort" :placeholder="$t('请输入排序')" />
        </el-form-item>
        <el-form-item :label="$t('货架类型')" prop="shelfType">
          <el-radio-group v-model="form.shelfType">
                <el-radio v-for="shelfTypeItem in shelfTypeDatas" :key="shelfTypeItem.value" :label="parseInt(shelfTypeItem.value)">{{shelfTypeItem.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
       
        <el-form-item :label="$t('状态')" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio v-for="statusItem in statusDictDatas" :key="statusItem.value" :label="parseInt(statusItem.value)">{{statusItem.value == CommonStatusEnum.ENABLE + '' ? '显示' : '不显示'}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createShelfGrid, updateShelfGrid, deleteShelfGrid, getShelfGrid, getShelfGridPage, exportShelfGridExcel } from "@/api/ecw/shelfGrid";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import {CommonStatusEnum} from '@/utils/constants'

export default {
  name: "ShelfGrid",
  components: {
  },
  data() {
    return {
      shelfTypeDatas: getDictDatas(DICT_TYPE.ECW_SHELF_TYPE),
      CommonStatusEnum: CommonStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),

      shelfId: this.$route.query.shelfId,
      warehouseName: this.$route.query.warehouseName,


      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 货架格子列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        shelfId: null,
        regionCode: null,
        shelfNo: null,
        volume: null,
        shelfType: null,
        sort: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        sort: [{ required: true, message: this.$t("排序不能为空"), trigger: "blur" }],
      }
    };
  },

  computed: {
    statusName() {
      return value => {
        for(let index in this.statusDictDatas) {
          let dictItem = this.statusDictDatas[index];
          if(dictItem.value == value) {
            return dictItem.value == CommonStatusEnum.ENABLE + '' ? this.$t('显示') : this.$t('不显示');
          }
        }
      }
    },

    shelfTypeName() {
      return value => {
        for(let index in this.shelfTypeDatas) {
          let dictItem = this.shelfTypeDatas[index];
          if(dictItem.value == value) {
            return dictItem.label;
          }
        }
      }
    },
  },

  activated() {
      let newShelfId = this.$route.query.shelfId;
      if(this.shelfId != newShelfId) {
        this.shelfId = newShelfId;
        this.queryParams.pageNo = 1;
        this.getList();
      }
  },

  created() {
    this.getList();
  },
  methods: {

    /** 查询列表 */
    getList() {
      let vm = this;
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      params.shelfId = this.shelfId;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getShelfGridPage(params).then(response => {
        this.list = response.data.list;

        this.list.forEach(function(element) {
          element.warehouseName = vm.warehouseName;
        })

        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        shelfId: undefined,
        regionCode: undefined,
        shelfNo: undefined,
        volume: undefined,
        shelfType: undefined,
        sort: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加货架格子");
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getShelfGrid(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t("修改货架格子");
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateShelfGrid(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createShelfGrid(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除货架格子编号为"' + id + '"的数据项?').then(function() {
          return deleteShelfGrid(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有货架格子数据项?').then(() => {
          this.exportLoading = true;
          return exportShelfGridExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
